﻿@page "/filmes"
@using System.Collections.Generic
@inject IJSRuntime JSRuntime
@using CadastroAtletasWasm.Helpers
@using CadastroAtletasWasm.Models
@using System.Globalization

<h3>Meus Filmes</h3>

@if (movies == null)
{
    <p><em>Carregando...</em></p>
}
else
{
    <div class="card">
        <label>Título do Filme</label>
        <input @bind="newMovie.Titulo" type="text" /><br>
        <label>Descrição do Filme</label>
        <input @bind="newMovie.Descricao" type="text" /><br>
        <label class="movie-attributes">Classificação:</label>
        <select @bind="newMovie.Classificacao">
            <option>Selecione</option>
            <option>Livre</option>
            <option>10 Anos</option>
            <option>14 Anos</option>
            <option>16 Anos</option>
            <option>18 Anos</option>
        </select><br>

         @if(movieToEdit == null)
        {
            <button class='btn btn-primary' @onclick="Gravar">ADICIONAR NOVO FILME</button>
        }
        else
        {
            <button class='btn btn-primary' @onclick="Gravar">EDITAR FILME</button><br>
            <button class='btn btn-danger' @onclick="Reset">CANCELAR</button>
        }
    </div>

    <div class="card mt-2">
        <label>LISTA DE FILMES</label>
        <div class="table-responsive-lg">
            <table class="table table-hover table-striped">
                <thead>
                    <tr>
                        <th>Título do Filme</th>
                        <th>Descrição do Filme</th>
                        <th>Classificação</th>
                        <th>Avaliação Média</th>
                        <th>Ações</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach (var movie in movies)
                    {
                        <tr>
                            <td>@movie.Titulo</td>
                            <td>@movie.Descricao</td>
                            <td>@movie.Classificacao</td>
                            <td>@movie.MediaAvaliacoes</td>
                            <td>
                                <button class='btn btn-primary' @onclick="() => Alterar(movie)">Editar</button>
                                <button class='btn btn-danger' @onclick="() => Excluir(movie.Id)">Excluir</button>
                            </td>
                        </tr>
                    }
                </tbody>
            </table>
        </div>
    </div>
}

@code {
    protected async override Task OnInitializedAsync()
    {
        movies = await api.RetornarTodosAsync();

        foreach (var movie in movies)
        {
            movie.MediaAvaliacoes = await api.GetMediaAvaliacoesDoFilme(movie.Id);
        }
    }

    private AcessoApi<Filme> api = new AcessoApi<Filme>("api/filme");

    private IList<Filme>? movies;

    private Filme newMovie = new Filme();

    private Filme? movieToEdit;

    private void Alterar(Filme objeto)
    {

        if(objeto.Classificacao == "Selecione")
        {
            objeto.Classificacao = "";
        }

            movieToEdit = new Filme
            {
                Id = objeto.Id,
                Titulo = objeto.Titulo,
                Descricao = objeto.Descricao,
                Classificacao = objeto.Classificacao
            };
            newMovie = new Filme
            {
                Titulo = objeto.Titulo,
                Descricao = objeto.Descricao,
                Classificacao = objeto.Classificacao,
            };
        
        
    }

    private void ClearForm()
    {
        newMovie.Titulo = string.Empty;
        newMovie.Descricao = string.Empty;
        newMovie.Classificacao = string.Empty;
    }


    private async void Excluir(string? id)
    {
        if (id != null)
        {
            await api.ExcluirAsync(id);
            movies = await api.RetornarTodosAsync();
            this.StateHasChanged();
        }
    }

    private void Reset()
    {
        movieToEdit = null;
        ClearForm();
    }

    private async void Gravar()
    {
       
            if (movieToEdit == null)
            {
                if(newMovie.Classificacao == "Selecione")
                {
                    newMovie.Classificacao = "";
                }
                else
                {
                await api.InserirAsync(newMovie);
                }
            }
            else
            {
                newMovie.Id = movieToEdit.Id;
                if(newMovie.Classificacao == "Selecione")
                {
                    newMovie.Classificacao = "";
                }
                else
                {
                    await api.AlterarAsync(newMovie);
                    movieToEdit = null;
                }
            }

            newMovie = new Filme();
            movies = await api.RetornarTodosAsync();
            this.StateHasChanged();
        
    }

    public class Filme : IModelo
    {
        public string? Id { get; set; }
        
        public string Titulo { get; set; } = "";

        public string Descricao { get; set; }

        public string Classificacao { get; set; }

        public double MediaAvaliacoes { get; set; }
    }

}
